/* client.h
 *
 * Contains prototypes and data structures for the client.
 */

#ifndef _CLIENT_H
#define _CLIENT_H

#include <OB/CORBA.h>
#include <OB/CosNaming.h>
#include <Game.h>

/**************
 * PROTOTYPES *
 **************/

// Main function for the client.  This is called by the corba setup code in 
// corba_client.cpp.
int client_main(int argc, char *argv[], Game_var game, unsigned long playerId, 
                unsigned long gameId, int serverId, 
                CosNaming::NamingContext_var nc);

// Wrapper for calling the Game::update() remote method
bool try_update(Game_var game, struct ClientAction &action);


#endif

