#include <mysql.h> /* Headers for MySQL usage */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "sql_lib.h"
#include "game_constants.h"


/***********
 * GLOBALS *
 ***********/

static MYSQL borba_db;
static char *host = "mysql.ece.cmu.edu";
static char *username = "c18749t7";
static char *password = "borba";


/*************
 * FUNCTIONS *
 *************/

/*
void main()
{
  db_connect();
  db_drop_all_tables();
  db_create_master_table();

  unsigned long *game_id = new unsigned long;
  unsigned long *player_id = new unsigned long;

  db_add_player(game_id, player_id);
  cout << "game_id = " << *game_id << "\nplayer_id = " << *player_id << endl;
  
  db_add_player(game_id, player_id);
  cout << "game_id = " << *game_id << "\nplayer_id = " << *player_id << endl;

  db_add_player(game_id, player_id);
  cout << "game_id = " << *game_id << "\nplayer_id = " << *player_id << endl;

  db_add_player(game_id, player_id);
  cout << "game_id = " << *game_id << "\nplayer_id = " << *player_id << endl;

  // 5th player, 2nd game
  db_add_player(game_id, player_id);
  cout << "game_id = " << *game_id << "\nplayer_id = " << *player_id << endl;

  delete game_id;
  delete player_id;

  db_populate_tables();

  struct GameState gamestate;
  struct GameState *gs = &gamestate;

  // write from DB into gs
  db_get_gamestate(1, gs);

  // test it!
  cout << "\n\nGameState: "
       << "\ngame_id = " << gs->game_id
       << "\nseq_num = " << gs->seq_num
       << "\nstatus = " << gs->status
       << "\nnumber_players = " << gs->number_players
       << "\nround number = " << gs->round_number
       << "\ntime_left = " << gs->time_left << endl;

  int i;
  for(i = 0; i < gs->number_players; i++){
    struct PlayerInfo *pi = &(gs->players[i]);

    cout << "PlayerInfo: "
	 << "\nplayer_id = " << pi->player_id
	 << "\ngame_id = " << pi->game_id
	 << "\nseq_num = " << pi->seq_num
	 << "\nstatus = " << pi->status
	 << "\nx_coord = " << pi->x_coord
	 << "\ny_coord = " << pi->y_coord
	 << "\nbombs_dropped = " << pi->bombs_dropped
	 << "\nrounds_won = " << pi->rounds_won << endl;

    int j;
    for(j = 0; j < pi->bombs_dropped; j++){
      struct BombInfo *bombs = &(pi->bombs[j]);
      cout << "BombInfo: "
	   << "\nbomb_id = " << bombs->bomb_id
	   << "\nplayer_id = " << bombs->player_id
	   << "\nstatus = " << bombs->status
	   << "\nx_coord = " << bombs->x_coord
	   << "\ny_coord = " << bombs->y_coord;

      int k;
      for(k = 0; k < NUM_PLAYERS; k++){
	cout << "\ndet_seq_num[" << k << "] = " << bombs->det_seq_num[k];
      }

      cout << endl;
    }
  }


  cout << "\n\nSET\n";

  // write from gs to DB
  struct GameState gamestate2;
  struct GameState *gs2 = &gamestate2;

  // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  gs2->game_id = 1;
  gs2->seq_num = 5;
  gs2->status = 1;
  gs2->number_players = 2;
  gs2->round_number = 3;
  gs2->time_left = 5;
  map_str_to_array(MAP1, gs2);

  struct PlayerInfo *pi2 = &(gs2->players[0]);
  pi2->player_id = 1;
  pi2->game_id = 1;
  pi2->seq_num = 100;
  pi2->status = 0;
  pi2->x_coord = 4;
  pi2->y_coord = 4;
  pi2->bombs_dropped = 1;
  pi2->rounds_won = 1;

  struct BombInfo *b = &(pi2->bombs[0]);
  b->bomb_id = 1;
  b->player_id = 1;
  b->status = 2;
  b->x_coord = 3;
  b->y_coord = 8;

  int p;
  for(p = 0; p < NUM_PLAYERS; p++){
    b->det_seq_num[p] = 0;
  }

  struct PlayerInfo *pi3 = &(gs2->players[1]);
  pi3->player_id = 2;
  pi3->game_id = 1;
  pi3->seq_num = 500;
  pi3->status = 0;
  pi3->x_coord = 6;
  pi3->y_coord = 6;
  pi3->bombs_dropped = 0;
  pi3->rounds_won = 2;

  struct PlayerInfo *pi4 = &(gs2->players[2]);
  pi4->player_id = 0;

  struct PlayerInfo *pi5 = &(gs2->players[3]);
  pi5->player_id = 0;



  cout << "OK\n";

  cout << "GameState: "
       << "\ngame_id = " << gs2->game_id
       << "\nseq_num = " << gs2->seq_num
       << "\nstatus = " << gs2->status
       << "\nnumber_players = " << gs2->number_players
       << "\nround number = " << gs2->round_number
       << "\ntime_left = " << gs2->time_left << endl;

  int k;
  for(k = 0; k < gs2->number_players; k++){
    struct PlayerInfo *pi = &(gs2->players[k]);

    cout << "PlayerInfo: "
	 << "\nplayer_id = " << pi->player_id
	 << "\ngame_id = " << pi->game_id
	 << "\nstatus = " << pi->status
	 << "\nx_coord = " << pi->x_coord
	 << "\ny_coord = " << pi->y_coord
	 << "\nbombs_dropped = " << pi->bombs_dropped
	 << "\nrounds_won = " << pi->rounds_won << endl;

    int j;
    for(j = 0; j < pi->bombs_dropped; j++){
      struct BombInfo *bombs = &(pi->bombs[j]);

      cout << "BombInfo: "
	   << "\nbomb_id = " << bombs->bomb_id
	   << "\nplayer_id = " << bombs->player_id
	   << "\nstatus = " << bombs->status
	   << "\nx_coord = " << bombs->x_coord
	   << "\ny_coord = " << bombs->y_coord << endl;
    }
  }


  db_set_gamestate(gs2);

  return 0;
}
*/

int db_connect()
{
  /* Make connection with mysql_connect(MYSQL db, char *host, char *username,
     char *password */
  if(!mysql_connect(&borba_db, host, username, password)){ 
    printf(mysql_error(&borba_db));
    return ERROR;
  }

  /* Select the database we want to use */
  if(mysql_select_db(&borba_db, username) == ERROR){
    printf(mysql_error(&borba_db));
    return ERROR;
  }

  return 0;
}

int db_disconnect()
{
  mysql_close(&borba_db);
  return SUCCESS;
}

void db_create_master_table()
{
  char query[255];

  // Create GameStateMaster table
  sprintf(query,
	  "CREATE TABLE GameStateMaster ("
	  "id INT NOT NULL AUTO_INCREMENT PRIMARY KEY)");
  mysql_real_query(&borba_db, query, strlen(query));

  // Create PlayerMaster table
  sprintf(query,
	  "CREATE TABLE PlayerMaster ("
	  "id INT NOT NULL AUTO_INCREMENT PRIMARY KEY)");
  mysql_real_query(&borba_db, query, strlen(query));
}

int db_create_tables(int game_id)
{
  char query[255];

  // Create GameState table
  sprintf(query,
	  "CREATE TABLE GameState%d ("
	  "id INT NOT NULL PRIMARY KEY, "
	  "seq_num INT, "
	  "status INT, "
	  "round_number INT, "
	  "time_left INT, "
	  "mapstring VARCHAR(%d))", game_id, NUM_ROWS*NUM_COLS+1);
  if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
    printf(mysql_error(&borba_db));
  }

  // Create Player table
  sprintf(query, 
	  "CREATE TABLE Player%d ("
	  "id int NOT NULL PRIMARY KEY, "
	  "game_id INT, "
	  "seq_num INT, "
	  "player_number INT, "
	  "status INT, "
	  "x_coord INT, "
	  "y_coord INT, "
	  "bombs_max INT, "
	  "rounds_won INT, "
	  "FOREIGN KEY (game_id) REFERENCES GameState(id))", game_id);
  if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
    printf(mysql_error(&borba_db));
  }

  // Create Bomb table
  sprintf(query,
	  "CREATE TABLE Bomb%d ("
	  "id INT NOT NULL AUTO_INCREMENT PRIMARY KEY, "
	  "player_id INT, "
	  "status INT, "
	  "x_coord INT, "
	  "y_coord INT, "
	  "det_seq_num1 INT, "
	  "det_seq_num2 INT, "
	  "det_seq_num3 INT, "
	  "det_seq_num4 INT, "
	  "FOREIGN KEY (player_id) REFERENCES Player(id))", game_id);
  if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
    printf(mysql_error(&borba_db));
  }

  return SUCCESS;
}

int db_drop_all_tables()
{
  char query[255];

  sprintf(query,
	  "SELECT id FROM GameStateMaster "
	  "ORDER BY id DESC "
	  "LIMIT 1");
  // Table does not exist
  if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR)
    return SUCCESS;

  MYSQL_RES *res;
  MYSQL_ROW row;
  res = mysql_store_result(&borba_db);
  row = mysql_fetch_row(res);

  if(row != NULL){
    int number_games = atoi(row[0]);

    int count = 1;
    while(count <= number_games){
      sprintf(query, "DROP TABLE GameState%d", count);
      mysql_real_query(&borba_db, query, strlen(query));

      sprintf(query, "DROP TABLE Bomb%d", count);
      mysql_real_query(&borba_db, query, strlen(query));

      sprintf(query, "DROP TABLE Player%d", count);
      mysql_real_query(&borba_db, query, strlen(query));

      ++count;
    }
  }
  
  sprintf(query, "DROP TABLE GameStateMaster");
  mysql_real_query(&borba_db, query, strlen(query));

  sprintf(query, "DROP TABLE PlayerMaster");
  mysql_real_query(&borba_db, query, strlen(query));

  mysql_free_result(res);

  return SUCCESS;
}

int db_populate_tables()
{
  char query[255];

  /*
  // GameState
  sprintf(query,
	  "INSERT INTO GameState (seq_num, status, round_number, time_left, mapstring) VALUES (0,1,2,3, '%s')");
  mysql_real_query(&borba_db, query, strlen(query));

  sprintf(query,
	  "INSERT INTO GameState (seq_num, status, round_number, time_left) VALUES (110,111,112,113)");
  mysql_real_query(&borba_db, query, strlen(query));

  // Player
  sprintf(query,
	  "INSERT INTO Player1 (id, game_id, seq_num, player_number, status, x_coord, y_coord, bombs_max, rounds_won) VALUES (1,1,0,1,1,0,0,3,1)");
  mysql_real_query(&borba_db, query, strlen(query));

  sprintf(query,
	  "INSERT INTO Player (game_id, seq_num, player_number, status, x_coord, y_coord, bombs_max, rounds_won) VALUES (3,1,0,2,1,0,14,3,2)");
  mysql_real_query(&borba_db, query, strlen(query));
  */

  // Bomb
  sprintf(query,
	  "INSERT INTO Bomb1 (player_id, status, x_coord, y_coord, "
	  "det_seq_num1, det_seq_num2, det_seq_num3, det_seq_num4) "
	  "VALUES (1,0,0,0,0,0,0,0)");
  mysql_real_query(&borba_db, query, strlen(query));

  sprintf(query,
	  "INSERT INTO Bomb1 (player_id, status, x_coord, y_coord, "
	  "det_seq_num1, det_seq_num2, det_seq_num3, det_seq_num4) "
	  "VALUES (1,0,3,4,0,0,0,0)");
  mysql_real_query(&borba_db, query, strlen(query));

  sprintf(query,
	  "INSERT INTO Bomb1 (player_id, status, x_coord, y_coord, "
	  "det_seq_num1, det_seq_num2, det_seq_num3, det_seq_num4) "
	  "VALUES (3,0,3,4,0,0,0,0)");
  mysql_real_query(&borba_db, query, strlen(query));

  sprintf(query,
	  "INSERT INTO Bomb2 (player_id, status, x_coord, y_coord, "
	  "det_seq_num1, det_seq_num2, det_seq_num3, det_seq_num4) "
	  "VALUES (5,0,3,4,0,0,0,0)");
  mysql_real_query(&borba_db, query, strlen(query));

  /*
  // Map
  sprintf(query,
	  "INSERT INTO Map (game_id, mapstring) VALUES (%d, '%s')",
	  1, "garbagemapdata");
  mysql_real_query(&borba_db, query, strlen(query));
  */
  return SUCCESS;
}

int db_check_games()
{
  char query[255];
  int  game_id;
  MYSQL_RES *res;
  MYSQL_ROW row;

  db_lock_table("GameStateMaster");

  // Select the latest game (has the largest id)  
  sprintf(query,
	  "SELECT id FROM GameStateMaster "
	  "ORDER BY id DESC "
	  "LIMIT 1");
  //sprintf(query, "SELECT max(id) FROM GameStateMaster");
  if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
    printf(mysql_error(&borba_db));
    db_unlock_all_tables();
    return ERROR;
  }

  res = mysql_store_result(&borba_db);
  row = mysql_fetch_row(res);

  // No games have been created yet
  if(row == NULL)
    game_id = -1;
  else {
    // Count number of players in this game
    game_id = atoi(row[0]);
    mysql_free_result(res);
    res = NULL;

    cout << "Create player: game_id = " << game_id << endl;

    db_lock_all_tables(game_id, LOCK_WRITE);

    sprintf(query, "SELECT status FROM GameState%d", game_id);
    if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
      printf(mysql_error(&borba_db));
      db_unlock_all_tables();
      return ERROR;
    }

    res = mysql_store_result(&borba_db);
    row = mysql_fetch_row(res);

    int status = atoi(row[0]);
    mysql_free_result(res);
    res = NULL;

    sprintf(query, "SELECT COUNT(DISTINCT id) FROM Player%d", game_id);
    if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
      printf(mysql_error(&borba_db));
      db_unlock_all_tables();
      return ERROR;
    }

    res = mysql_store_result(&borba_db);
    row = mysql_fetch_row(res);

    int number_players = atoi(row[0]);
    if(status != GSTAT_WAITING || number_players >= NUM_PLAYERS)
      game_id = -1;
  }

  mysql_free_result(res);

  return game_id;
}

int db_create_game()
{
  char query[255];
  int  game_id;
  
  db_lock_table("GameStateMaster");

  // Add the Master GameState table
  sprintf(query, "INSERT INTO GameStateMaster () VALUES ()");
  if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
    printf(mysql_error(&borba_db));
    db_unlock_all_tables();
    return ERROR;
  }

  // Find what id the new game was given
  game_id = mysql_insert_id(&borba_db);

  // Create a new set of tables for this new game
  if(db_create_tables(game_id) == ERROR){
    db_unlock_all_tables();
    return ERROR;
  }

  db_lock_all_tables(game_id, LOCK_WRITE);

  // Add to the game-specific GameState table
  sprintf(query,
	  "INSERT INTO GameState%d "
	  "VALUES (%d, %d, %d, %d, %d, '%s')",
	  game_id,
	  game_id, 0, GSTAT_WAITING, 1, ROUND_TIME, MAP1);
  if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
    printf(mysql_error(&borba_db));
    db_unlock_all_tables();
    return ERROR;
  }

  return game_id;
}

int db_create_player(int game_id)
{
  char query[255];
  MYSQL_RES *res;
  MYSQL_ROW row;
  int  x_coord;
  int  y_coord;
  int  player_num;
  bool pnums[NUM_PLAYERS];  // stores TRUE for player numbers that are in use

  for (int i = 0; i < NUM_PLAYERS; i++) {
    pnums[i] = false;
  }

  //db_begin_transaction();

  // figure out which player number to use
  sprintf(query, 
          "SELECT player_number FROM Player%d", game_id);
  if (mysql_real_query(&borba_db, query, strlen(query)) == ERROR) {
    //db_rollback_transaction();
    printf(mysql_error(&borba_db));
    db_unlock_all_tables();
    return ERROR;
  }

  res = mysql_store_result(&borba_db);
  while ((row = mysql_fetch_row(res)) != NULL) {
    // NOTE: player_number values go from 1-4 instead of 0-3
    player_num = atoi(row[0]);
    if ((player_num >= 1) && (player_num <= NUM_PLAYERS)) {
      pnums[player_num-1] = true;
    } else {
      cerr << "ERROR: database has invalid player_number value: " 
           << player_num << endl;
    }
  }

  // find the first number not in use
  player_num = 0;
  for (int i = 0; i < NUM_PLAYERS; i++) {
    if (pnums[i] == false) {
      player_num = i+1;
      break;
    }
  }

  // setup the player location (based on player number)
  switch (player_num) {
    case 1:
      x_coord = y_coord = 0;
      break;
    case 2:
      x_coord = NUM_COLS - 1;
      y_coord = 0;
      break;
    case 3:
      x_coord = 0;
      y_coord = NUM_ROWS - 1;
      break;
    case 4:
      x_coord = NUM_COLS - 1;
      y_coord = NUM_ROWS - 1;
      break;
    default:
      cerr << "ERROR: database has invalid player_number value: " 
           << player_num << endl;
      return ERROR;
      break;
  }

  // Generate a new player id
  sprintf(query, "INSERT INTO PlayerMaster () VALUES ()");
  if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
    printf(mysql_error(&borba_db));
    db_unlock_all_tables();
    return ERROR;
  }

  int player_id = mysql_insert_id(&borba_db);

  // Create a new player
  sprintf(query, 
	  "INSERT INTO Player%d "
	  "VALUES (%d, %d, %d, %d, %d, %d, %d, %d, %d)",
	  game_id,
	  player_id, game_id, 0, player_num, PSTAT_ALIVE,
	  x_coord, y_coord, MAX_BOMBS, 0);
  if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
    printf(mysql_error(&borba_db));
    db_unlock_all_tables();
    return ERROR;
  }

  // Set game to active when we have NUM_PLAYERS
  if(player_num == NUM_PLAYERS){
    sprintf(query, "UPDATE GameState%d SET status = %d WHERE id = %d", 
	    game_id, GSTAT_ACTIVE, game_id);
    if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
      printf(mysql_error(&borba_db));
      db_unlock_all_tables();
      return ERROR;
    }
  }

  return player_id;
}

int db_exit_game(unsigned long game_id, unsigned long player_id)
{
  char query[255];
  MYSQL_RES *res;
  MYSQL_ROW row;

  //db_begin_transaction();

  db_lock_all_tables(game_id, LOCK_WRITE);

  sprintf(query, "UPDATE Player%d SET status = %d WHERE id = %d",
	  game_id, PSTAT_LEFTGAME, player_id);
  if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
    //db_rollback_transaction();
    printf(mysql_error(&borba_db));
    db_unlock_all_tables();
    return ERROR;
  }

  // FIXME: If this is the last player, do clean up
  /*
    // Delete all players from Player
    sprintf(query,
    "DELETE FROM Player WHERE id = %d", player_id);
    printf("query: %s\n", query);

    if(mysql_real_query(&borba_db, query, strlen(query)) != 0){
    db_rollback_transaction();
    printf(mysql_error(&borba_db));
    return ERROR;
    }

    db_commit_transaction();
  */

  sprintf(query,
	  "SELECT COUNT(DISTINCT id) FROM GameState%d "
	  "WHERE status != %d AND status != %d",
	  game_id, PSTAT_DISCONNECTED, PSTAT_LEFTGAME);

  if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
    printf(mysql_error(&borba_db));
    db_unlock_all_tables();
    return ERROR;
  }

  res = mysql_store_result(&borba_db);
  row = mysql_fetch_row(res);

  if(row == NULL){
    mysql_free_result(res);
    db_unlock_all_tables();
    return ERROR;
  }

  int number_players = atoi(row[0]);
  if(number_players == 0) {
    mysql_free_result(res);
    db_unlock_all_tables();
    return DELETE_GAME;
  }

  db_unlock_all_tables();

  mysql_free_result(res);

  return SUCCESS;
}

int db_add_player(unsigned long *game_id, unsigned long *player_id)
{
  char query[255];
  int create_game_flag = 0;

  // Create a new game if all games are full
  *game_id = db_check_games();
  if (*game_id == -1) {
    *game_id = db_create_game();
    create_game_flag = -1;
  }

  sprintf(query, "LOCK TABLES PlayerMaster WRITE, "
	  "GameState%d WRITE, Player%d WRITE, Bomb%d WRITE", 
	  *game_id, *game_id, *game_id);
  if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
    printf(mysql_error(&borba_db));
    db_unlock_all_tables();
    return ERROR;
  }

  *player_id = db_create_player(*game_id);

  db_unlock_all_tables();

  return create_game_flag;
}

int db_get_gamestate(unsigned long game_id, struct GameState *gs)
{
  char query[255];
  MYSQL_RES *res;
  MYSQL_ROW row;

  db_lock_all_tables(game_id, LOCK_WRITE);

  sprintf(query,
	  "SELECT * FROM GameState%d",
	  game_id);
  if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
    printf(mysql_error(&borba_db));
    db_unlock_all_tables();
    return ERROR;
  }

  res = mysql_store_result(&borba_db);
  row = mysql_fetch_row(res);

  // Game not found
  if(row == NULL){
    db_unlock_all_tables();
    return ERROR;
  }

  gs->game_id = strtoul(row[0], NULL, 10);
  gs->seq_num = strtoul(row[1], NULL, 10);
  gs->status  = strtoul(row[2], NULL, 10);
  gs->round_number = strtoul(row[3], NULL, 10);
  gs->time_left = strtoul(row[4], NULL, 10);
  map_str_to_array(row[5], gs);

  mysql_free_result(res);
  res = NULL;

  sprintf(query,
	  "SELECT COUNT(DISTINCT id) FROM Player%d",
	  game_id);
  if (mysql_real_query(&borba_db, query, strlen(query)) == ERROR) {
    printf(mysql_error(&borba_db));
    db_unlock_all_tables();
    return ERROR;
  }

  res = mysql_store_result(&borba_db);
  row = mysql_fetch_row(res);

  if(row == NULL)
    gs->number_players = 0;
  else
    gs->number_players = strtoul(row[0], NULL, 10);

  mysql_free_result(res);

  // Fills up the players struct
  if(db_get_all_players(gs) == ERROR){
    db_unlock_all_tables();
    return ERROR;
  }

  //db_unlock_all_tables();

  return SUCCESS;
}

int db_get_all_players(struct GameState *gs)
{
  char query[255];
  MYSQL_RES *res;
  MYSQL_ROW row;

  sprintf(query,
	  "SELECT * FROM Player%d ORDER BY player_number ASC",
	  gs->game_id);
  if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
    printf(mysql_error(&borba_db));
    return ERROR;
  }

  res = mysql_store_result(&borba_db);

  int count = 0;
  while((row = mysql_fetch_row(res)) != NULL){
    struct PlayerInfo *pi = &(gs->players[count]);

    pi->player_id  = strtoul(row[0], NULL, 10);
    pi->game_id    = strtoul(row[1], NULL, 10);
    pi->seq_num    = strtoul(row[2], NULL, 10);
    pi->status     = strtoul(row[4], NULL, 10);  
    pi->x_coord    = strtoul(row[5], NULL, 10);
    pi->y_coord    = strtoul(row[6], NULL, 10);
    pi->rounds_won = strtoul(row[8], NULL, 10);

    int bombs_dropped;
    if((bombs_dropped = db_get_all_bombs(pi)) == ERROR){
      mysql_free_result(res);
      return ERROR;
    }
    else
      pi->bombs_dropped = (unsigned long)bombs_dropped;

    ++count;
  }

  int i;
  for(i = count; i < NUM_PLAYERS; i++){
    struct PlayerInfo *pi = &(gs->players[count]);
    pi->player_id = INVALID_ID;
  }
  
  mysql_free_result(res);

  return SUCCESS;
}

int db_get_all_bombs(struct PlayerInfo *pi)
{
  char query[255];
  MYSQL_RES *res;
  MYSQL_ROW row;

  sprintf(query,
	  "SELECT * FROM Bomb%d "
	  "WHERE player_id = %d AND status != %d "
	  "ORDER BY id ASC",
	  pi->game_id, pi->player_id, EXPLODED);
  if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
    printf(mysql_error(&borba_db));
    return ERROR;
  }

  res = mysql_store_result(&borba_db);

  int count = 0;
  while((row = mysql_fetch_row(res)) != NULL){
    struct BombInfo *bomb = &(pi->bombs[count]);
    
    bomb->bomb_id   = strtoul(row[0], NULL, 10);
    bomb->player_id = strtoul(row[1], NULL, 10);
    bomb->status    = strtoul(row[2], NULL, 10);
    bomb->x_coord   = strtoul(row[3], NULL, 10);
    bomb->y_coord   = strtoul(row[4], NULL, 10);

    int i;
    for(i = 0; i < NUM_PLAYERS; i++)
      bomb->det_seq_num[i] = strtoul(row[i+5], NULL, 10);

    ++count;
  }

  int i;
  for(i = count; i < MAX_BOMBS; i++){
    struct BombInfo *bomb = &(pi->bombs[i]);
    bomb->bomb_id = INVALID_ID;
  }

  mysql_free_result(res);

  return count;
}

int db_set_gamestate(struct GameState *gs)
{
  char query[1024];
  char mapstring[NUM_ROWS*NUM_COLS+1];

  //db_lock_all_tables(gs->game_id, LOCK_WRITE);

  map_array_to_str(mapstring, gs);

  // set GameState
  sprintf(query,
	  "UPDATE GameState%d "
	  "SET seq_num = %d, status = %d, round_number = %d, time_left = %d, "
	  "mapstring = '%s' "
	  "WHERE id = %d",
	  gs->game_id,
	  gs->seq_num, gs->status, gs->round_number, gs->time_left, mapstring,
	  gs->game_id);

  if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
    printf(mysql_error(&borba_db));
    db_unlock_all_tables();
    return ERROR;
  }

  // set Player and Bomb
  if(db_set_all_players(gs) == ERROR){
    db_unlock_all_tables();
    return ERROR;
  }

  db_unlock_all_tables();

  return SUCCESS;
}

int db_set_all_players(struct GameState *gs)
{
  char query[255];

  int i;
  for(i = 0; i < NUM_PLAYERS; i++){
    struct PlayerInfo *pi = &(gs->players[i]);

    if(pi->player_id != INVALID_ID){
      sprintf(query,
	      "UPDATE Player%d "
	      "SET seq_num = %d, status = %d, x_coord = %d, y_coord = %d, "
	      "rounds_won = %d "
	      "WHERE id = %d",
	      pi->game_id,
	      pi->seq_num, pi->status, pi->x_coord, pi->y_coord, pi->rounds_won, 
	      pi->player_id);
      if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
	printf(mysql_error(&borba_db));
	return ERROR;
      }

      // set Bomb
      if(db_set_all_bombs(pi) == ERROR)
	return ERROR;
    }
  }

  return SUCCESS;
}

int db_set_all_bombs(struct PlayerInfo *pi)
{
  char query[255];

  int j;
  for(j = 0; j < MAX_BOMBS; j++){
    struct BombInfo *bomb = &(pi->bombs[j]);

    if(bomb->status == NEW){
      sprintf(query, 
	      "INSERT INTO Bomb%d (player_id, status, x_coord, y_coord, "
	      "det_seq_num1, det_seq_num2, det_seq_num3, det_seq_num4) "
	      "VALUES (%d, %d, %d, %d, %d, %d, %d, %d)",
	      pi->game_id, 
	      bomb->player_id, UNEXPLODED, bomb->x_coord, bomb->y_coord,
	      bomb->det_seq_num[0], bomb->det_seq_num[1],
	      bomb->det_seq_num[2], bomb->det_seq_num[3]);

      if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
        printf(mysql_error(&borba_db));
        return ERROR;
      }
    }
    else{
      if(bomb->bomb_id != INVALID_ID){
	sprintf(query,
		"UPDATE Bomb%d "
		"SET status = %d, x_coord = %d, y_coord = %d "
		"WHERE id = %d",
		pi->game_id,
		bomb->status, bomb->x_coord, bomb->y_coord, bomb->bomb_id);

	if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
	  printf(mysql_error(&borba_db));
	  return ERROR;
	}
      } // if
    } // else
  } // for
  
  return SUCCESS;
}

// FIX: do these transactions need to rollback if fail?
int db_begin_transaction()
{
  char query[255];

  sprintf(query, "BEGIN");

  if(mysql_real_query(&borba_db, query, strlen(query)) != 0){
    printf(mysql_error(&borba_db));
    return ERROR;
  }

  return SUCCESS;

}

int db_commit_transaction()
{
  char query[255];

  sprintf(query, "COMMIT");

  if(mysql_real_query(&borba_db, query, strlen(query)) != 0){
    printf(mysql_error(&borba_db));
    return ERROR;
  }

  return SUCCESS;
}

int db_rollback_transaction()
{
  char query[255];

  sprintf(query, "ROLLBACK");

  if(mysql_real_query(&borba_db, query, strlen(query)) != 0){
    printf(mysql_error(&borba_db));
    return ERROR;
  }

  return SUCCESS;
}

int db_lock_table(char *table)
{
  char query[255];

  sprintf(query, "LOCK TABLES %s WRITE", table);
  //printf("%s\n", query);

  if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
    printf("ERROR %s\n", query);
    printf(mysql_error(&borba_db));
    return ERROR;
  }

  return SUCCESS;
}

int db_lock_all_tables(int game_id, int lock_type)
{
  char query[255];

  if(lock_type == LOCK_READ)
    sprintf(query, "LOCK TABLES GameState%d READ, Player%d READ, "
	    "Bomb%d READ", game_id, game_id, game_id);
  else if(lock_type == LOCK_WRITE)
    sprintf(query, "LOCK TABLES GameState%d WRITE, Player%d WRITE, "
	    "Bomb%d WRITE", game_id, game_id, game_id);
  //printf("%s\n", query);

  if(mysql_real_query(&borba_db, query, strlen(query)) == ERROR){
    printf(mysql_error(&borba_db));
    return ERROR;
  }

  return SUCCESS;
}

int db_unlock_all_tables()
{
  char query[255];

  sprintf(query, "UNLOCK TABLES");
  //printf("%s\n", query);

  if(mysql_real_query(&borba_db, query, strlen(query)) != 0){
    printf(mysql_error(&borba_db));
    return ERROR;
  }

  return SUCCESS;
}

void map_str_to_array(const char *map_str, struct GameState *gs) {
  const char *p = map_str;
  for (int row = 0; row < NUM_ROWS; row++) {
    for (int col = 0; col < NUM_COLS; col++) {
      gs->map_info[row][col] = *p - '0';
      p++;
    }
  }
}

void map_array_to_str(char *map_str, const struct GameState *gs) {
  char *p = map_str;
  for (int row = 0; row < NUM_ROWS; row++) {
    for (int col = 0; col < NUM_COLS; col++) {
      *p = gs->map_info[row][col] + '0';
      p++;
    }
  }
  *p = '\0';
}
