/*************
 * CONSTANTS *
 *************/

// number of players per game
#define NUM_PLAYERS        4

// size of the map
#define NUM_ROWS           11
#define NUM_COLS           15

// max number of bombs each player can drop
#define MAX_BOMBS          3

// player status 
#define PSTAT_ALIVE        0
#define PSTAT_DEAD         1

// movement directions
#define MOVE_UP            0
#define MOVE_DOWN          1
#define MOVE_LEFT          2
#define MOVE_RIGHT         3
#define MOVE_NONE          4

// map tile types
#define MAP_EMPTY          0      // empty space
#define MAP_WALL           1      // un-bombable wall
#define MAP_BRICK          2      // bombable brick

// game constants
#define GSTAT_ACTIVE       0
#define GSTAT_WAITING      1
