// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef GAME_IMPL_H
#define GAME_IMPL_H

#include <Game_skel.h>

class Game_impl : public POA_Game,
                  public PortableServer::RefCountServantBase
{
  //
  // The ORB
  //
  CORBA::ORB_var orb_;

  //
  // The servants default POA
  //
  PortableServer::POA_var poa_;

  public:

  Game_impl(CORBA::ORB_ptr orb, PortableServer::POA_ptr poa);

  ~Game_impl();

  struct GameState
    Game_impl::update( const struct ClientAction &arg1 )
    throw(CORBA::SystemException);

  virtual void
    shutdown()
    throw (CORBA::SystemException);

  virtual PortableServer::POA_ptr
    _default_POA();
};

#endif
